<template> 
  <div class="fluid container">
    <h1>Drag & Drop Template Builder</h1>
    <div class="row">
      <div class="form-group">
        <label class="control-label col-sm-2" for="name">Nombre del template</label>
        <div class="col-sm-10">
          <div class="search input-group">
            <input id="name" v-model="templateName" class="form-control" placeholder="Nombre del template" type="text">
            <span class="input-group-btn">
              <button class="btn btn-success" type="submit" @click.prevent="sendData()">
                <span class="glyphicon glyphicon-send"></span>
                <span class="sr-only">Search</span>
              </button>
            </span>
          </div>
          <p class="help-block">Ingrese aquí el nombre del template.</p>
        </div>
      </div>
    </div>
    <div class="row">
      <div  class="col-md-2">
          <draggable class="list-group" element="ul" v-model="list" :options="{group:{ name:'items',  pull:'clone', put:false }, ghostClass: 'ghost', animation : 10}" :clone="onClone" @start="isDragging=true" @end="isDragging=false"> 
            <transition-group type="transition" :name="'flip-list'">
              <li class="list-group-item" v-for="element in list" :key="element.name">               
                
                {{element.name}}

              </li> 
            </transition-group>
        </draggable>
      </div>
       <div  class="col-md-2">
        <draggable element="span" v-model="list2" :options="{group: {name: 'items', pull: 'move'}, ghostClass: 'ghost'}"> 
            <transition-group name="no" class="list-group" tag="ul">
              <li class="list-group-item" v-for="element in list2" :key="element.name"> 
                {{element.name}}              
              </li> 
            </transition-group>
        </draggable>
      </div>

       <div class="col-md-2">
        <draggable element="div" id="droppable" class="list-group" :options="{group: {name:'items'}}">           
        </draggable>
      </div>


      <div  class="list-group col-md-3">
        <pre> {{ listString }} </pre>
      </div>
       <div  class="list-group col-md-3">
        <pre> {{ list2String }} </pre>
      </div> 
    </div>


    <h1>Vista del Estudiante</h1>

    <div class="row">
      <template v-for="item in list2">
        <component :is="item.component" :key="item.id" :value.sync="item.value"></component>
      </template>
    </div>

  </div>
</template>

<script>

  import draggable              from 'vuedraggable'
  import componentList          from '../utils/ComponentManager'
  import bubbles                from './CourseBuilder/bubbles/builder.vue'
  import audiocontainer         from './CourseBuilder/Containers/audio/builder.vue'
  import ResultTypes            from '../utils/ResultTypes'

  export default {
    name: 'drag',
    components: {
      draggable,
      bubbles,
      audiocontainer,
    },
    data(){
      return {
        templateName: '',
        list: componentList,
        list2:[],
        editable:true,
        isDragging: false,
        delayedDragging:false,

          weeks : [
                    [       
                        {
                            "name": "",
                            "type": "",
                            "slide_index": 0,
                            "slides": [
                                {  
                                    "name": "",
                                    "component": "",
                                    "miniatura": "",
                                    "category": "",
                                    "value": {},
                                    "icon": "",
                                    "result": ResultTypes.PENDING
                                },
                            ],
                            "favorite": false,
                            "completed": false
                        },
                    ],
                ]  
            }
    },
    methods:{
      onClone(e){
        if(this.list2.length > 9 )
          return ;
          let clone = Object.assign({}, e)
          clone.id = this.createHash()
          return clone
      },
      createHash(){
          return (((1+Math.random())*0x10000)|0).toString(16).substring(1) + (((1+Math.random())*0x10000)|0).toString(16).substring(1); 
      },
      sendData(){
        console.log('Data: ' + this.templateName + ' ' + JSON.stringify(this.list2))
      }
    },
    computed: {
      listString(){
        return JSON.stringify(this.list, null, 2);  
      },
      list2String(){
        return JSON.stringify(this.list2, null, 2);  
      }
    },
    watch: {
      isDragging (newValue) {
        if (newValue){
          this.delayedDragging= true
          return
        }
        this.$nextTick( () =>{
             this.delayedDragging =false
        })
      }
    }
  }

</script>

<style>
.flip-list-move {
  transition: transform 0.5s;
}
.no-move {
  transition: transform 0s;
}
.ghost {
  opacity: .5;
  background: #C8EBFB;
}
.list-group {
  min-height: 20px;
}
.list-group-item {
  cursor: move;
}
.list-group-item i{
  cursor: pointer;
}


#droppable {
  border: 2px dashed #f60;
  min-height: 100px;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
}

#droppable::before {
  font-family: 'Glyphicons Halflings';
  color: #ccc;
  font-size: 40px;
  content: "\E020";
  text-align: center;
}

#droppable > * {
  border: 2px dashed #060;
  position: absolute;
  top: -2px;
  left: -2px;
  right: -2px;
  bottom: -2px;
  font-size: 20px;
  text-align: center;
  text-decoration: line-through;
  display: flex;
  align-items: center;
  justify-content: center;
}


</style>